searchNodes=[{"doc":"","ref":"Proximal.html","title":"Proximal","type":"protocol"},{"doc":"Transforms a data structure to Xmlel structure.","ref":"Proximal.html#to_xmlel/1","title":"Proximal.to_xmlel/1","type":"function"},{"doc":"","ref":"Proximal.html#t:t/0","title":"Proximal.t/0","type":"type"},{"doc":"When you need to implement a parser for a structure, you could add the following code: defmodule MyStruct do use Proximal.Document alias Proximal.Xmlel defstruct [ :name , :surname ] @impl Proximal.Document def render ( % __MODULE__ { name : name , surname : surname } ) do Xmlel . new ( &quot;mystruct&quot; , %{ } , [ Xmlel . new ( &quot;name&quot; , %{ } , [ name ] ) , Xmlel . new ( &quot;surname&quot; , %{ } , [ surname ] ) ] ) end end The code should let you to create your data in the way you need and thanks to the implementation of the render/1 function, you could use: % MyStruct { name : &quot;Manuel&quot; , surname : &quot;Rubio&quot; } |&gt; Proximal . to_xmlel ( ) To get the representation in %Xmlel{} structs and even adding at the end of that pipe to_string/1 to get the XML in a string.","ref":"Proximal.Document.html","title":"Proximal.Document","type":"behaviour"},{"doc":"","ref":"Proximal.Document.html#c:render/1","title":"Proximal.Document.render/1","type":"callback"},{"doc":"XML-RPC let us to create method calls and responses. It works in both directions, encoding/decoding requests and encoding/decoding responses.","ref":"Proximal.Rpc.html","title":"Proximal.Rpc","type":"module"},{"doc":"Decode params passed to the RPC system. It's performing the opposite as encode_params/1 does.","ref":"Proximal.Rpc.html#decode_params/1","title":"Proximal.Rpc.decode_params/1","type":"function"},{"doc":"Decode a response from RPC. This performs the complementary of encode_response/1 . Examples: iex&gt; import Proximal.Xmlel , only : [ sigil_x : 2 ] iex&gt; ~x[&lt;methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;Manuel&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;] iex&gt; |&gt; Proximal.Rpc . decode_request ( ) { &quot;io_puts&quot; , [ &quot;Manuel&quot; ] } iex&gt; import Proximal.Xmlel , only : [ sigil_x : 2 ] iex&gt; ~x[&lt;methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;int&gt;100&lt;/int&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;] iex&gt; |&gt; Proximal.Rpc . decode_request ( ) { &quot;io_puts&quot; , [ 100 ] } iex&gt; import Proximal.Xmlel , only : [ sigil_x : 2 ] iex&gt; ~x[&lt;methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;base64&gt;AAAA&lt;/base64&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;] iex&gt; |&gt; Proximal.Rpc . decode_request ( ) { &quot;io_puts&quot; , [ &lt;&lt; 0 , 0 , 0 &gt;&gt; ] } iex&gt; import Proximal.Xmlel , only : [ sigil_x : 2 ] iex&gt; ~x[&lt;methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;nil/&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;] iex&gt; |&gt; Proximal.Rpc . decode_request ( ) { &quot;io_puts&quot; , [ nil ] } iex&gt; import Proximal.Xmlel , only : [ sigil_x : 2 ] iex&gt; ~x[&lt;methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;double&gt;10.5&lt;/double&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;] iex&gt; |&gt; Proximal.Rpc . decode_request ( ) { &quot;io_puts&quot; , [ 10.5 ] } iex&gt; import Proximal.Xmlel , only : [ sigil_x : 2 ] iex&gt; ~x[&lt;methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;dateTime.iso8601&gt;2019-03-31T02:30:00Z&lt;/dateTime.iso8601&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;] iex&gt; |&gt; Proximal.Rpc . decode_request ( ) { &quot;io_puts&quot; , [ ~N[2019-03-31 02:30:00] ] } iex&gt; import Proximal.Xmlel , only : [ sigil_x : 2 ] iex&gt; ~x[&lt;methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;dateTime.iso8601&gt;2019-03-31T02:30:00Z&lt;/dateTime.iso8601&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;] iex&gt; |&gt; Proximal.Rpc . decode_request ( ) { &quot;io_puts&quot; , [ ~N[2019-03-31 02:30:00] ] } iex&gt; import Proximal.Xmlel , only : [ sigil_x : 2 ] iex&gt; ~x[&lt;methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;struct&gt;&lt;member&gt;&lt;name&gt;name&lt;/name&gt;&lt;value&gt;&lt;string&gt;Manuel&lt;/string&gt;&lt;/value&gt;&lt;/member&gt;&lt;/struct&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;] iex&gt; |&gt; Proximal.Rpc . decode_request ( ) { &quot;io_puts&quot; , [ %{ &quot;name&quot; =&gt; &quot;Manuel&quot; } ] } iex&gt; import Proximal.Xmlel , only : [ sigil_x : 2 ] iex&gt; ~x[&lt;methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;array&gt;&lt;data&gt;&lt;value&gt;&lt;boolean&gt;1&lt;/boolean&gt;&lt;/value&gt;&lt;value&gt;&lt;boolean&gt;0&lt;/boolean&gt;&lt;/value&gt;&lt;value&gt;&lt;int&gt;10&lt;/int&gt;&lt;/value&gt;&lt;/data&gt;&lt;/array&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodCall&gt;&lt;methodName&gt;io_puts&lt;/methodName&gt;] iex&gt; |&gt; Proximal.Rpc . decode_request ( ) { &quot;io_puts&quot; , [ [ true , false , 10 ] ] }","ref":"Proximal.Rpc.html#decode_request/1","title":"Proximal.Rpc.decode_request/1","type":"function"},{"doc":"","ref":"Proximal.Rpc.html#decode_value/1","title":"Proximal.Rpc.decode_value/1","type":"function"},{"doc":"","ref":"Proximal.Rpc.html#encode_params/1","title":"Proximal.Rpc.encode_params/1","type":"function"},{"doc":"Encode a response. Providing a data, it's generating the XML-RPC valid response. Example: iex&gt; Proximal.Rpc . encode_response ( 100 ) iex&gt; |&gt; to_string ( ) &quot;&lt;methodResponse&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;int&gt;100&lt;/int&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodResponse&gt;&quot; iex&gt; Proximal.Rpc . encode_response ( &lt;&lt; 0 , 0 , 0 &gt;&gt; ) iex&gt; |&gt; to_string ( ) &quot;&lt;methodResponse&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;base64&gt;AAAA&lt;/base64&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodResponse&gt;&quot; iex&gt; Proximal.Rpc . encode_response ( nil ) iex&gt; |&gt; to_string ( ) &quot;&lt;methodResponse&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;nil/&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodResponse&gt;&quot; iex&gt; Proximal.Rpc . encode_response ( 10.5 ) iex&gt; |&gt; to_string ( ) &quot;&lt;methodResponse&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;double&gt;10.5&lt;/double&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodResponse&gt;&quot; iex&gt; Proximal.Rpc . encode_response ( DateTime . new! ( ~D[2019-03-31] , ~T[02:30:00] ) ) iex&gt; |&gt; to_string ( ) &quot;&lt;methodResponse&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;dateTime.iso8601&gt;2019-03-31T02:30:00Z&lt;/dateTime.iso8601&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodResponse&gt;&quot; iex&gt; Proximal.Rpc . encode_response ( NaiveDateTime . new! ( ~D[2019-03-31] , ~T[02:30:00] ) ) iex&gt; |&gt; to_string ( ) &quot;&lt;methodResponse&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;dateTime.iso8601&gt;2019-03-31T02:30:00Z&lt;/dateTime.iso8601&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodResponse&gt;&quot; iex&gt; Proximal.Rpc . encode_response ( %{ &quot;name&quot; =&gt; &quot;Manuel&quot; } ) iex&gt; |&gt; to_string ( ) &quot;&lt;methodResponse&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;struct&gt;&lt;member&gt;&lt;name&gt;name&lt;/name&gt;&lt;value&gt;&lt;string&gt;Manuel&lt;/string&gt;&lt;/value&gt;&lt;/member&gt;&lt;/struct&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodResponse&gt;&quot; iex&gt; Proximal.Rpc . encode_response ( [ true , false , 10 ] ) iex&gt; |&gt; to_string ( ) &quot;&lt;methodResponse&gt;&lt;params&gt;&lt;param&gt;&lt;value&gt;&lt;array&gt;&lt;data&gt;&lt;value&gt;&lt;boolean&gt;1&lt;/boolean&gt;&lt;/value&gt;&lt;value&gt;&lt;boolean&gt;0&lt;/boolean&gt;&lt;/value&gt;&lt;value&gt;&lt;int&gt;10&lt;/int&gt;&lt;/value&gt;&lt;/data&gt;&lt;/array&gt;&lt;/value&gt;&lt;/param&gt;&lt;/params&gt;&lt;/methodResponse&gt;&quot;","ref":"Proximal.Rpc.html#encode_response/1","title":"Proximal.Rpc.encode_response/1","type":"function"},{"doc":"","ref":"Proximal.Rpc.html#encode_value/1","title":"Proximal.Rpc.encode_value/1","type":"function"},{"doc":"Process a stream chunk by chunk to obtain a XML document. The stream is initiated passing a PID where the information from the chunks are going to be received. The parser is using Proximal.Handler.Sender which is responsible to convert the stream data into a valid %Xmlel{} and send it back to the specified process.","ref":"Proximal.Stream.html","title":"Proximal.Stream","type":"module"},{"doc":"Creates a new Saxy.Partial struct to parser little by little the incoming stream. The information is sent back to the pid passed as a paramter, by default this is set as self() .","ref":"Proximal.Stream.html#new/1","title":"Proximal.Stream.new/1","type":"function"},{"doc":"Use it to send every chunk of the XML document(s) we want to parse. Every chunk will be sent back to the process passed initially in the new function through the partial parameter.","ref":"Proximal.Stream.html#parse/2","title":"Proximal.Stream.parse/2","type":"function"},{"doc":"When we wants to send the rest of the XML document(s) we have to use this function which let us to finalise the partial data. Note that because a change into the Saxy 1.4, everytime we terminate a ending document, it will be in the :halt state, otherwise it will generate a parsing error.","ref":"Proximal.Stream.html#terminate/1","title":"Proximal.Stream.terminate/1","type":"function"},{"doc":"Xmlel is a struct data which is intended to help with the parsing of the XML elements.","ref":"Proximal.Xmlel.html","title":"Proximal.Xmlel","type":"module"},{"doc":"Provide the name of the children tags. Examples: iex&gt; import Proximal.Xmlel , only : [ sigil_x : 2 ] iex&gt; xmlel = ~x[&lt;root&gt;&lt;child1/&gt;&lt;child2/&gt;&lt;child3/&gt;&lt;/root&gt;] iex&gt; Proximal.Xmlel . children_tag_names ( xmlel ) [ &quot;child1&quot; , &quot;child2&quot; , &quot;child3&quot; ]","ref":"Proximal.Xmlel.html#children_tag_names/1","title":"Proximal.Xmlel.children_tag_names/1","type":"function"},{"doc":"This function removes the extra spaces inside of the stanzas starting from xmlel to ensure we can perform matching in a proper way. Examples: iex&gt; &quot;&lt;foo&gt; \\n &lt;bar&gt; \\n Hello&lt;br/&gt;world! \\n &lt;/bar&gt; \\n &lt;/foo&gt;&quot; iex&gt; |&gt; Proximal.Xmlel . parse ( ) iex&gt; |&gt; Proximal.Xmlel . clean_spaces ( ) iex&gt; |&gt; to_string ( ) &quot;&lt;foo&gt;&lt;bar&gt;Hello&lt;br/&gt;world!&lt;/bar&gt;&lt;/foo&gt;&quot;","ref":"Proximal.Xmlel.html#clean_spaces/1","title":"Proximal.Xmlel.clean_spaces/1","type":"function"},{"doc":"This function is a helper function to translate the tuples coming from Saxy into de data parameter to the Proximal.Xmlel structs. Examples: iex&gt; Proximal.Xmlel . decode ( { &quot;foo&quot; , [ ] , [ ] } ) % Proximal.Xmlel { name : &quot;foo&quot; , attrs : %{ } , children : [ ] } iex&gt; Proximal.Xmlel . decode ( { &quot;foo&quot; , [ ] , [ { :characters , &quot;1&amp;1&quot; } ] } ) % Proximal.Xmlel { name : &quot;foo&quot; , children : [ &quot;1&amp;1&quot; ] } iex&gt; Proximal.Xmlel . decode ( { &quot;bar&quot; , [ { &quot;id&quot; , &quot;10&quot; } ] , [ &quot;Hello!&quot; ] } ) % Proximal.Xmlel { name : &quot;bar&quot; , attrs : %{ &quot;id&quot; =&gt; &quot;10&quot; } , children : [ &quot;Hello!&quot; ] }","ref":"Proximal.Xmlel.html#decode/1","title":"Proximal.Xmlel.decode/1","type":"function"},{"doc":"Deletes an attribute by name from a xmlel struct. Examples: iex&gt; attrs = %{ &quot;id&quot; =&gt; &quot;100&quot; , &quot;name&quot; =&gt; &quot;Alice&quot; } iex&gt; xmlel = % Proximal.Xmlel { attrs : attrs } iex&gt; Proximal.Xmlel . get_attr ( xmlel , &quot;name&quot; ) &quot;Alice&quot; iex&gt; Proximal.Xmlel . delete_attr ( xmlel , &quot;name&quot; ) iex&gt; |&gt; Proximal.Xmlel . get_attr ( &quot;name&quot; ) nil","ref":"Proximal.Xmlel.html#delete_attr/2","title":"Proximal.Xmlel.delete_attr/2","type":"function"},{"doc":"This function is a helper function to translate the content of the xmlel structs to the tuples needed by Saxy. Examples: iex&gt; Proximal.Xmlel . encode ( % Proximal.Xmlel { name : &quot;foo&quot; } ) { &quot;foo&quot; , [ ] , [ ] } iex&gt; Proximal.Xmlel . encode ( % Proximal.Xmlel { name : &quot;bar&quot; , attrs : %{ &quot;id&quot; =&gt; &quot;10&quot; } , children : [ &quot;Hello!&quot; ] } ) { &quot;bar&quot; , [ { &quot;id&quot; , &quot;10&quot; } ] , [ { :characters , &quot;Hello!&quot; } ] } iex&gt; Proximal.Xmlel . encode ( % TestBuild { name : &quot;bro&quot; } ) { &quot;bro&quot; , [ ] , [ ] }","ref":"Proximal.Xmlel.html#encode/1","title":"Proximal.Xmlel.encode/1","type":"function"},{"doc":"Access the value stored under key passing the stanza in Proximal.Xmlel format into the xmlel parameter. Examples: iex&gt; import Proximal.Xmlel iex&gt; el = ~x(&lt;foo&gt;&lt;c1 v=&quot;1&quot;/&gt;&lt;c1 v=&quot;2&quot;/&gt;&lt;c2/&gt;&lt;/foo&gt;) iex&gt; fetch ( el , &quot;c1&quot; ) { :ok , [ % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;1&quot; } , children : [ ] , name : &quot;c1&quot; } , % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;2&quot; } , children : [ ] , name : &quot;c1&quot; } ] } iex&gt; fetch ( el , &quot;nonexistent&quot; ) :error","ref":"Proximal.Xmlel.html#fetch/2","title":"Proximal.Xmlel.fetch/2","type":"function"},{"doc":"Access the value under key and update it at the same time for the xmlel using the function passed as paramter. Examples: iex&gt; import Proximal.Xmlel iex&gt; el = ~x(&lt;foo&gt;&lt;c1 v=&quot;1&quot;/&gt;&lt;c1 v=&quot;2&quot;/&gt;&lt;c2/&gt;&lt;/foo&gt;) iex&gt; fun = fn els -&gt; iex&gt; values = Enum . map ( els , fn % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; v } } = el -&gt; % Proximal.Xmlel { el | attrs : %{ &quot;v&quot; =&gt; &quot;v&quot; &lt;&gt; v } } end ) iex&gt; { els , values } iex&gt; end iex&gt; get_and_update ( el , &quot;c1&quot; , fun ) { [ % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;1&quot; } , children : [ ] , name : &quot;c1&quot; } , % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;2&quot; } , children : [ ] , name : &quot;c1&quot; } ] , % Proximal.Xmlel { attrs : %{ } , children : [ % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;v1&quot; } , children : [ ] , name : &quot;c1&quot; } , % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;v2&quot; } , children : [ ] , name : &quot;c1&quot; } , % Proximal.Xmlel { attrs : %{ } , children : [ ] , name : &quot;c2&quot; } ] , name : &quot;foo&quot; } } iex&gt; fun = fn _els -&gt; :pop end iex&gt; get_and_update ( el , &quot;c1&quot; , fun ) { [ % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;1&quot; } , children : [ ] , name : &quot;c1&quot; } , % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;2&quot; } , children : [ ] , name : &quot;c1&quot; } ] , % Proximal.Xmlel { attrs : %{ } , children : [ % Proximal.Xmlel { attrs : %{ } , children : [ ] , name : &quot;c2&quot; } ] , name : &quot;foo&quot; } }","ref":"Proximal.Xmlel.html#get_and_update/3","title":"Proximal.Xmlel.get_and_update/3","type":"function"},{"doc":"Retrieve an attribute by name from a xmlel struct. If the value is not found the default value is used instead. If default is not provided then nil is used as default value. Examples: iex&gt; attrs = %{ &quot;id&quot; =&gt; &quot;100&quot; , &quot;name&quot; =&gt; &quot;Alice&quot; } iex&gt; xmlel = % Proximal.Xmlel { attrs : attrs } iex&gt; Proximal.Xmlel . get_attr ( xmlel , &quot;name&quot; ) &quot;Alice&quot; iex&gt; Proximal.Xmlel . get_attr ( xmlel , &quot;surname&quot; ) nil","ref":"Proximal.Xmlel.html#get_attr/3","title":"Proximal.Xmlel.get_attr/3","type":"function"},{"doc":"Creates a Xmlel struct passing the name of the stanza, the attrs as a map or keyword list to create the attributes and children for the payload of the XML tag. This is not recursive so it's intended the children has to be in a correct format. The children could be or binaries (strings) representing CDATA or other Proximal.Xmlel elements. Examples: iex&gt; Proximal.Xmlel . new ( &quot;foo&quot; ) % Proximal.Xmlel { attrs : %{ } , children : [ ] , name : &quot;foo&quot; } iex&gt; Proximal.Xmlel . new ( &quot;bar&quot; , %{ &quot;id&quot; =&gt; &quot;10&quot; } ) % Proximal.Xmlel { attrs : %{ &quot;id&quot; =&gt; &quot;10&quot; } , children : [ ] , name : &quot;bar&quot; } iex&gt; Proximal.Xmlel . new ( &quot;bar&quot; , [ { &quot;id&quot; , &quot;10&quot; } ] ) % Proximal.Xmlel { attrs : %{ &quot;id&quot; =&gt; &quot;10&quot; } , children : [ ] , name : &quot;bar&quot; }","ref":"Proximal.Xmlel.html#new/3","title":"Proximal.Xmlel.new/3","type":"function"},{"doc":"Parser a xml string into Proximal.Xmlel struct. Examples: iex&gt; Proximal.Xmlel . parse ( &quot;&lt;foo/&gt;&quot; ) { % Proximal.Xmlel { name : &quot;foo&quot; , attrs : %{ } , children : [ ] } , &quot;&quot; } iex&gt; Proximal.Xmlel . parse ( &quot;&lt;foo bar=&#39;10&#39;&gt;hello world!&lt;/foo&gt;&quot; ) { % Proximal.Xmlel { name : &quot;foo&quot; , attrs : %{ &quot;bar&quot; =&gt; &quot;10&quot; } , children : [ &quot;hello world!&quot; ] } , &quot;&quot; } iex&gt; Proximal.Xmlel . parse ( &quot;&lt;foo&gt;&lt;bar&gt;hello world!&lt;/bar&gt;&lt;/foo&gt;&quot; ) { % Proximal.Xmlel { name : &quot;foo&quot; , attrs : %{ } , children : [ % Proximal.Xmlel { name : &quot;bar&quot; , attrs : %{ } , children : [ &quot;hello world!&quot; ] } ] } , &quot;&quot; } iex&gt; Proximal.Xmlel . parse ( &quot;&lt;foo/&gt;&lt;bar/&gt;&quot; ) { % Proximal.Xmlel { name : &quot;foo&quot; , attrs : %{ } , children : [ ] } , &quot;&lt;bar/&gt;&quot; }","ref":"Proximal.Xmlel.html#parse/1","title":"Proximal.Xmlel.parse/1","type":"function"},{"doc":"Pop the value under key passed an Proximal.Xmlel struct as element . Examples: iex&gt; import Proximal.Xmlel iex&gt; el = ~x(&lt;foo&gt;&lt;c1 v=&quot;1&quot;/&gt;&lt;c1 v=&quot;2&quot;/&gt;&lt;c2/&gt;&lt;/foo&gt;) iex&gt; pop ( el , &quot;c1&quot; ) { [ % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;1&quot; } , children : [ ] , name : &quot;c1&quot; } , % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;2&quot; } , children : [ ] , name : &quot;c1&quot; } ] , % Proximal.Xmlel { attrs : %{ } , children : [ % Proximal.Xmlel { attrs : %{ } , children : [ ] , name : &quot;c2&quot; } ] , name : &quot;foo&quot; } } iex&gt; pop ( el , &quot;nonexistent&quot; ) { [ ] , % Proximal.Xmlel { attrs : %{ } , children : [ % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;1&quot; } , children : [ ] , name : &quot;c1&quot; } , % Proximal.Xmlel { attrs : %{ &quot;v&quot; =&gt; &quot;2&quot; } , children : [ ] , name : &quot;c1&quot; } , % Proximal.Xmlel { attrs : %{ } , children : [ ] , name : &quot;c2&quot; } ] , name : &quot;foo&quot; } }","ref":"Proximal.Xmlel.html#pop/2","title":"Proximal.Xmlel.pop/2","type":"function"},{"doc":"Add or set a value by name as attribute inside of the xmlel struct passed as parameter. Examples: iex&gt; attrs = %{ &quot;id&quot; =&gt; &quot;100&quot; , &quot;name&quot; =&gt; &quot;Alice&quot; } iex&gt; % Proximal.Xmlel { attrs : attrs } iex&gt; |&gt; Proximal.Xmlel . put_attr ( &quot;name&quot; , &quot;Bob&quot; ) iex&gt; |&gt; Proximal.Xmlel . get_attr ( &quot;name&quot; ) &quot;Bob&quot;","ref":"Proximal.Xmlel.html#put_attr/3","title":"Proximal.Xmlel.put_attr/3","type":"function"},{"doc":"Add or set one or several attributes using fields inside of the xmlel struct passed as parameter. The fields data are in keyword list format. Examples: iex&gt; fields = %{ &quot;id&quot; =&gt; &quot;100&quot; , &quot;name&quot; =&gt; &quot;Alice&quot; , &quot;city&quot; =&gt; &quot;Cordoba&quot; } iex&gt; Proximal.Xmlel . put_attrs ( % Proximal.Xmlel { name : &quot;foo&quot; } , fields ) |&gt; to_string ( ) &quot;&lt;foo city= \\&quot; Cordoba \\&quot; id= \\&quot; 100 \\&quot; name= \\&quot; Alice \\&quot; /&gt;&quot; iex&gt; fields = %{ &quot;id&quot; =&gt; &quot;100&quot; , &quot;name&quot; =&gt; &quot;Alice&quot; , &quot;city&quot; =&gt; :&quot;Cordoba&quot; } iex&gt; Proximal.Xmlel . put_attrs ( % Proximal.Xmlel { name : &quot;foo&quot; } , fields ) |&gt; to_string ( ) &quot;&lt;foo id= \\&quot; 100 \\&quot; name= \\&quot; Alice \\&quot; /&gt;&quot;","ref":"Proximal.Xmlel.html#put_attrs/2","title":"Proximal.Xmlel.put_attrs/2","type":"function"},{"doc":"Sigil to use ~X to provide XML string and transform it to Xmlel struct. Note that we are not using addons . Examples: iex&gt; import Proximal.Xmlel iex&gt; ~X|&lt;foo&gt; iex&gt; &lt;/foo&gt; iex&gt; | % Proximal.Xmlel { attrs : %{ } , children : [ &quot; \\n &quot; ] , name : &quot;foo&quot; }","ref":"Proximal.Xmlel.html#sigil_X/2","title":"Proximal.Xmlel.sigil_X/2","type":"function"},{"doc":"Sigil to use ~x to provide XML string and transform it to Xmlel struct removing spaces and breaking lines. Note that we are not using addons . Examples: iex&gt; import Proximal.Xmlel iex&gt; ~x|&lt;foo&gt; iex&gt; &lt;/foo&gt; iex&gt; | % Proximal.Xmlel { attrs : %{ } , children : [ ] , name : &quot;foo&quot; }","ref":"Proximal.Xmlel.html#sigil_x/2","title":"Proximal.Xmlel.sigil_x/2","type":"function"},{"doc":"","ref":"Proximal.Xmlel.html#t:attr_name/0","title":"Proximal.Xmlel.attr_name/0","type":"type"},{"doc":"","ref":"Proximal.Xmlel.html#t:attr_value/0","title":"Proximal.Xmlel.attr_value/0","type":"type"},{"doc":"","ref":"Proximal.Xmlel.html#t:attrs/0","title":"Proximal.Xmlel.attrs/0","type":"type"},{"doc":"","ref":"Proximal.Xmlel.html#t:children/0","title":"Proximal.Xmlel.children/0","type":"type"},{"doc":"Xmlel. t defines the xmlel element which contains the name , the attrs (attributes) and children for the XML tags.","ref":"Proximal.Xmlel.html#t:t/0","title":"Proximal.Xmlel.t/0","type":"type"},{"doc":"proXiMaL proXiMaL is an advanced library for XML which let you to handle XML documents is a better way thanks to the Elixir idioms implemented. It's built on top of Saxy which is providing the needed mechanisms to perform the parsing and building of the XML documents. This library is 100% Elixir. No C, Rust or other language implementations are needed so, it's eligible to be in use for Nerves and embedded systems.","ref":"readme.html","title":"proXiMaL","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding proximal to your list of dependencies in mix.exs : def deps do [ { :proximal , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"proXiMaL - Installation","type":"extras"}]